program try

TYPE atype
character s1*10
character s2(10)
END TYPE

TYPE (atype) var1(5)

! error  note that var1 and s1(1:3) both are one_rank array type 
var1%s1(1:3)='asd'       
! correct
var1%s2(1:3)='asd'

end

